TREE(1)

NUME
tree - listează conținutul directoarelor într-un format arborescent.

SINOPSIS
tree [-acdfghilnpqrstuvxACDFJQNSUX] [-L nivel [-R]] [-H [-]baseHREF] [-T titlu] [-o nume-fișier] [-P model] [-I model] [--gitignore] [--gitfile[=]fișier] [--matchdirs] [--metafirst] [--ignore-case] [--nolinks] [--hintro[=]fișier] [--houtro[=]fișier] [--inodes] [--device] [--sort[=]nume] [--dirsfirst] [--filesfirst] [--filelimit [=]număr] [--si] [--du] [--prune] [--charset[=]X] [--timefmt[=]format] [--fromfile] [--fromtabfile] [--fflinks] [--info] [--infofile[=]fișier] [--noreport] [--hyperlink] [--scheme[=]schema] [--authority[=]nume-gazdă] [--opt-toggle] [--version] [--help] [--] [director ...]

DESCRIERE
tree este un program de listare recursivă a directoarelor care produce o listă de fișiere cu indentare în adâncime, care este colorată precum dircolors dacă variabila de mediu LS_COLORS este definită și dacă ieșirea este pe tty. Fără argumente, tree listează fișierele din directorul curent. În cazul în care se dau argumente pentru directoare, tree enumeră toate fișierele și/sau directoarele găsite în directoarele date, fiecare pe rând. La terminarea listării tuturor fișierelor/directoarelor găsite, tree returnează numărul total de fișiere și/sau directoare listate.

În mod implicit, atunci când se întâlnește o legătură simbolică, ruta la care se referă legătura simbolică este imprimată după numele legăturii în formatul:

    nume -> ruta-reală

Dacă se dă opțiunea „-l” și legătura simbolică se referă la un director real, atunci tree va urma ruta legăturii simbolice ca și cum ar fi un director real.

OPȚIUNI
tree înțelege următoarele opțiuni în linia de comandă:

OPȚIUNI DE LISTARE

-a  Toate fișierele sunt afișate. În mod implicit, tree nu afișează fișierele ascunse (cele care încep cu un punct „.”). În nici un caz tree nu afișează construcțiile sistemului de fișiere „.” (directorul curent) și „..” (directorul anterior).

-d  Listează numai directoarele.

-l  Urmărește legăturile simbolice dacă acestea indică directoare, ca și cum ar fi directoare. Legăturile simbolice care vor duce la recursivitate sunt evitate atunci când sunt detectate.

-f  Imprimă prefixul complet al rutei pentru fiecare fișier.

-x  Rămâne doar pe sistemul de fișiere curent. Ca și cum s-ar folosi find -xdev.

-L nivel
    Adâncimea maximă de afișare a arborelui de directoare.

-R  Coboară recursiv fiecare nivel de directoare din arbore (a se vedea opțiunea -L) și returnează un fișier numit OOTree.html la fiecare nivel (în maniera -o).

-P model
    Listează numai acele fișiere care se potrivesc cu caracterul joker model. Puteți avea mai multe opțiuni -P. Notă: trebuie să utilizați opțiunea -a pentru a lua în considerare și fișierele care încep cu un punct „.” pentru potrivire. Operatorii caracter-joker valabili sunt: „*” (orice zero sau mai multe caractere), „**” (orice zero sau mai multe caractere, precum și /-uri nule, adică /**/ poate corespunde unui singur /), „?” (orice caracter), „[...]” (orice caracter listat între paranteze (se poate utiliza opțional - (liniuță) pentru intervalul de caractere: de exemplu [A-Z]) și „[^...]” (orice caracter care nu este listat între paranteze) și „|” separă modelele alternative. Un caracter „/” la sfârșitul modelului corespunde directoarelor, dar nu și fișierelor.

-I model
    Nu listează acele fișiere care se potrivesc cu modelul joker. Puteți avea mai multe opțiuni -I. Consultați -P de mai sus pentru informații despre modelele cu caractere joker.

--gitignore
    Folosește fișierele git .gitignore pentru filtrarea fișierelor și directoarelor. De asemenea, utilizează $GIT_DIR/info/exclude dacă este prezent.

--gitfile[=]fișier
    Utilizează fișier în mod explicit ca fișier gitignore.

--ignore-case
    În cazul în care un model de potrivire este specificat prin opțiunea -P sau -I, modelul se va potrivi fără a se ține seama de diferențele dintre majuscule și minuscule.

--matchdirs
    În cazul în care se specifică un model de potrivire prin opțiunea -P, modelul va fi aplicat la numele directoarelor (în plus față de numele fișierelor). În cazul în care numele directorului se potrivește, potrivirea este dezactivată pentru conținutul directorului. În cazul în care se utilizează opțiunea --prune, dosarele goale care corespund modelului nu vor fi curățate.

--metafirst
    Imprimă informațiile privind metadatele la începutul liniei, mai degrabă decât după liniile de indentare.

--prune
    Face ca arborele să elimine directoarele goale de la ieșire, util atunci când este utilizată împreună cu -P sau -I. Pentru mai multe informații despre această opțiune, consultați secțiunea ERORI ȘI NOTE de mai jos.

--info
    Imprimă comentariile găsite în fișierele .info. Pentru mai multe informații despre formatul fișierelor .info, consultați secțiunea FIȘIERE .INFO de mai jos.

--infofile[=]fișier
    Utilizează fișier în mod explicit ca fișier info.

--noreport
    Omite imprimarea raportului de fișiere și directoare la sfârșitul listei arborelui.

--charset[=]set-caractere
    Stabilește setul de caractere care trebuie utilizat la ieșirea HTML și pentru desenarea liniilor.

--filelimit[=]număr
    Nu coboară directoarele care conțin mai mult de număr intrări.

--timefmt[=]format
    Imprimă (implică -D) și formatează data în conformitate cu șirul de format care utilizează sintaxa strftime(3).

-o nume-fișier
    Trimite ieșirea la nume-fișier.

OPȚIUNI FIȘIER

-q  Imprimă caracterele neimprimabile din numele de fișier sub formă de semne de întrebare în loc de cele implicite.

-N  Imprimă caracterele neimprimabile ca atare în loc de numere octale eludate.

-Q  Introduce numele fișierelor între ghilimele duble.

-p  Afișează tipul de fișier și permisiunile pentru fiecare fișier (ca în cazul comenzii «ls -l»).

-u  Afișează numele de utilizator, sau numărul UID dacă nu există un nume de utilizator, al fișierului.

-g  Afișează numele grupului sau numărul GID dacă nu este disponibil niciun nume de grup, al fișierului.

-s  Afișează dimensiunea fiecărui fișier în octeți împreună cu numele.

-h  Imprimă dimensiunea fiecărui fișier, dar într-un mod mai ușor de citit, de exemplu, adăugând o literă de mărime pentru kiloocteți (K), megaocteți (M), gigaocteți (G), teraocteți (T), petaocteți (P) și exaocteți (E).

--si
    Precum -h, dar se folosesc în loc unități SI (puteri de 1000).

--du
    Pentru fiecare director, raportează dimensiunea sa ca fiind cumularea dimensiunilor tuturor fișierelor și subdirectoarelor sale (și a fișierelor acestora, și așa mai departe). Cantitatea totală de spațiu utilizat este, de asemenea, indicată în raportul final (ca și în cazul comenzii «du -c»). Această opțiune necesită ca tree să citească întregul arbore de directoare înainte de a-l emite, a se vedea ERORI ȘI NOTE de mai jos. Implică -s.

-D  Imprimă data ultimei modificări sau, dacă se utilizează -c, data ultimei modificări de stare pentru fișierul listat.

-F  Adaugă un caracter „/” pentru directoare, un „=” pentru fișiere soclu, un „*” pentru fișiere executabile, un „>” pentru uși „doors” (Solaris) și un „|” pentru FIFO-uri, ca în cazul comenzii «ls -F».

--inodes
    Imprimă numărul de nod-i al fișierului sau directorului.

--device
    Imprimă numărul dispozitivului căruia îi aparține fișierul sau directorul.

OPȚIUNI DE SORTARE

-v  Sortează ieșirea în funcție de versiune.

-t  Sortează ieșirea în funcție de ultima oră de modificare în loc de ordine alfabetică.

-c  Sortează ieșirea în funcție de ultima modificare a stării în loc de ordine alfabetică. Modifică opțiunea -D (dacă este utilizată) pentru a imprima ultima modificare de stare în loc de ora de modificare.

-U  Nu sortează. Listează fișierele în ordinea din directoare. Dezactivează opțiunea --dirsfirst.

-r  Sortează ieșirea în ordine inversă. Aceasta este o meta-sortare care modifică sortările de mai sus. Această opțiune este dezactivată atunci când se utilizează opțiunea -U.

--dirsfirst
    Listează directoarele înaintea fișierelor. Aceasta este o meta-sortare care modifică sortările de mai sus. Această opțiune este dezactivată atunci când se utilizează opțiunea -U.

--filesfirst
    Listează fișierele înaintea directoarelor. Aceasta este o meta-sortare care modifică sortările de mai sus. Această opțiune este dezactivată atunci când se utilizează opțiunea -U.

--sort[=]tip
    Sortează ieșirea după tip în loc de nume. Valorile posibile sunt: ctime (-c), mtime (-t), size, sau version (-v) sau none (-U).

OPȚIUNI GRAFICE

-i  Face ca tree să nu imprime liniile de indentare, util atunci când este utilizată împreună cu opțiunea -f. De asemenea, elimină cât mai multe spații albe posibil atunci când este utilizată împreună cu opțiunile -J sau -X.

-A  Activează modificarea grafică a liniilor ANSI la imprimarea liniilor de indentare.

-S  Activează grafica de linie CP437 (utilă atunci când se utilizează fonturi în modul consolă Linux). Această opțiune este acum echivalentă cu „--charset=IBM437” și poate fi în cele din urmă depreciată.

-n  Dezactivează întotdeauna colorarea, anulată de opțiunea -C, însă anulează CLICOLOR_FORCE dacă este prezentă.

-C  Activează întotdeauna colorarea, utilizând culorile implicite încorporate dacă variabilele de mediu LS_COLORS sau TREE_COLORS nu sunt definite. Util pentru a colora ieșirea către o conductă.

OPȚIUNI XML/JSON/HTML/HYPERLINKS

-X  Activează ieșirea XML. Scoate arborele de directoare sub forma unui fișier în format XML.

-J  Activează ieșirea JSON. Afișează arborele de directoare ca o matrice formatată JSON.

-H [-]baseHREF
    Activează ieșirea HTML, inclusiv referințele HTTP. Util pentru siturile ftp. baseHREF oferă locația ftp de bază atunci când se utilizează ieșirea HTML. Adică, directorul local poate fi „/local/ftp/pub”, dar trebuie să fie menționat ca „ftp://hostname.organization.domain/pub” (baseHREF trebuie să fie „ftp://hostname.organization.domain”). Dacă baseHREF începe cu o liniuță (-), atunci liniuța este eliminată și indică faptul că tree ar trebui să elimine primul nume de director din URL-ul href. Indicație: nu utilizați linii ANSI cu această opțiune și nu indicați mai mult de un director în lista de directoare. Dacă doriți să utilizați culori prin intermediul foii de stil CSS, utilizați opțiunea -C în plus față de această opțiune pentru a forța ieșirea în culori.

--hintro[=]fișier
    Utilizează fișier ca introducere HTML în locul celui implicit. Utilizați un fișier gol sau /dev/null pentru a elimina complet introducerea.

--houtro[=]fișier
    Utilizează fișier ca picior de pagină HTML în locul celui implicit. Folosiți un fișier gol sau /dev/null pentru a elimina cu totul piciorul de pagină.

-T titlu
    Stabilește titlul și șirul de antet H1 în modul de ieșire HTML.

--nolinks
    Dezactivează hiperlegăturile în ieșirea HTML.

--hyperlink
    Activează hiperlegăturile terminale OSC 8 pentru terminalele care le acceptă. Consultați ERORI ȘI NOTE de mai jos.

--scheme[=]schema
    Stabilește schema utilizată în hiperlegăturile OSC 8. Schema implicită este „file://”. Dacă schema omite două puncte (:), atunci :// vor fi adăugate la schemă.

--authority[=]nume-gazdă|authoritate
    Stabilește autoritatea (numele de gazdă) care urmează să fie utilizată pentru hiperlegăturile OSC 8. În mod implicit, numele de gazdă local al mașinii, așa cum este returnat de gethostname(), este utilizat ca autoritate. Un punct (.) sau un set de ghilimele "", fără „=”, (adică șirul gol) poate fi utilizat pentru a indica o autoritate nulă.

OPȚIUNI DE INTRARE

--fromfile
    Citește o listă de directoare dintr-un fișier și nu din sistemul de fișiere. Rutele furnizate în linia de comandă sunt fișiere din care se citește și nu directoare în care se caută. Directorul cu punct (.) indică faptul că tree ar trebui să citească rutele de la intrarea standard. NOTĂ: acest lucru este adecvat numai pentru citirea ieșirii unui program precum find, nu pentru «tree -fi», deoarece legăturile simbolice nu se disting de fișierele care conțin pur și simplu „ -> ” ca parte a numelui de fișier, cu excepția cazului în care se utilizează opțiunea --fflinks.

--fromtabfile
    La fel ca și --fromfile, tree citește un arbore de directoare dintr-un fișier text în care fișierele sunt indentate cu tabulație într-un format asemănător unui arbore, pentru a indica nivelul de ierarhizare al directoarelor.

--fflinks
    Prelucrează informațiile privind legăturile simbolice găsite într-un fișier, ca în cazul ieșirii din «tree -fi --noreport». Numai prima apariție a șirului „-> ” este utilizată pentru a indica separarea numelui de fișier de legătură.

OPȚIUNI DIVERSE

--opt-toggle
    Activează „comutarea” opțiunilor. Activează posibilitatea de a comuta opțiuni precum „-a”, „-h” etc. Utilă pentru a adăuga la un alias atunci când doriți să dezactivați opțiunile activate în alias.

--help
    Afișează o listă de utilizare detaliată.

--version
    Afișează versiunea de tree.

--  Finalizatorul de procesare a opțiunii. După aceasta, nu vor mai fi procesate alte opțiuni.

FIȘIERE .INFO

Fișierele .info sunt similare fișierelor .gitignore; dacă un fișier .info este găsit în timpul scanării unui director, acesta este citit și adăugat la o stivă de informații .info. Fiecare fișier este compus din comentarii (linii care încep cu simboluri hash (#),) sau modele cu caractere joker care pot corespunde unui fișier în raport cu directorul în care se găsește fișierul .info. În cazul în care un fișier trebuie să corespundă unui model, comentariul indentat cu tabulație care urmează modelului este utilizat ca și comentariu al fișierului. Comentariul se termină cu o linie care nu este indentată cu tabulator. Mai multe modele, fiecare pe o linie, pot împărți același comentariu.

FIȘIERE
/etc/DIR_COLORS    Baza de date de culori a sistemului.
~/.dircolors    Baza de date de culori a utilizatorilor.
.gitignore    Fișierul de excludere git.
$GIT_DIR/info/exclude    Lista globală de excludere a fișierelor git.
.info    Fișier de comentariu al fișierului.
/usr/share/finfo/global_info    Fișier global de comentariu al fișierului.

MEDIU
LS_COLORS    Informații despre culori create de dircolors.
Folosește acest parametru pentru informații despre culori în loc de LS_COLORS, dacă este definită.
TREE_CHARSET    Set de caractere pentru arborele de utilizat în modul HTML.
Activează colorarea chiar dacă TREE_COLORS sau LS_COLORS nu sunt definite.
CLICOLOR_FORCE    Activează întotdeauna colorarea (efectiv -C).
NO_COLOR    Dezactivează colorarea (efectiv -n) ( a se vedea
https://no-color.org/).
LC_CTYPE    Configurația regională pentru afișarea numelui de fișier.
LC_TIME    Configurația regională pentru afișarea timefmt (formatul de
timp), a se vedea strftime(3).
TZ    Fusul orar pentru afișarea timefmt, a se vedea strftime(3).
STDDATA_FD    Activează caracteristica stddata, opțional definește
descriptorul de utilizat.

AUTOR
Steve Baker (Steve.Baker.llc@gmail.com)
Ieșire HTML construită de Francesc Rocher (rocher@econ.udg.es)
Suport pentru seturi de caractere și OS/2 de Kyosuke Tokoro (NBG01720@nifty.ne.jp).

ERORI ȘI NOTE
tree nu curăță directoarele „goale” atunci când opțiunile -P și -I sunt utilizate în mod implicit. Utilizați opțiunea --prune pentru aceasta.

Opțiunile -h și --si rotunjesc la cel mai apropiat număr întreg, spre deosebire de implementările ls, care rotunjesc întotdeauna în sus.

Suprimarea fișierelor și directoarelor cu opțiunile -I, -P și --filelimit va duce la rapoarte incorecte privind numărul de fișiere/directoare.

Opțiunile --prune și --du fac ca tree să acumuleze întregul arbore în memorie înainte de a-l emite. În cazul arborilor de directoare mari, acest lucru poate cauza o întârziere semnificativă a ieșirii și utilizarea unor cantități mari de memorie.

Memoria tampon de expansiune timefmt este limitată la un număr ridicol de mare de 255 de caractere. Ieșirea șirurilor de timp mai lungi decât aceasta va fi nedefinită, dar este garantat că nu va depăși 255 de caractere.

Arborii XML/JSON nu sunt colorați, ceea ce este un pic rușinos. Cu toate acestea, instrumentul jq poate colora JSON-ul, dar nu și numele fișierelor în funcție de tipul de fișier a la LS_COLORS.

Hiperlegăturile OSC 8 pot fi slab acceptate de terminalul dumneavoastră. Pentru versiunea mea de Konsole este necesar să definiți schema la file: (fără //) și să utilizați o autoritate nulă. De asemenea, poate fi necesar să petreceți 3,5 ore pentru a găsi opțiunea de activare a hiperlegăturilor.

Probabil mai multe.

Începând cu versiunea 2.0.0, în Linux, tree va încerca să emită automat un arbore JSON compact pe descriptorul de fișier 3 (ceea ce eu numesc stddata), dacă este prezentă și variabila de mediu STDDATA_FD este definită sau definită la un descriptor de fișier pozitiv diferit de zero, valoarea de utilizat pentru afișare. Se speră că într-o zi un shell Linux/Unix mai bun poate profita de această caracteristică, deși BSON ar fi probabil un format mai bun pentru aceasta.

CONSULTAȚI ȘI
dircolors(1), ls(1), find(1), du(1), jq(1), strftime(3), gitignore(5)

TRADUCERE
Traducerea în limba română a acestui manual a fost făcută de Remus-Gabriel Chelu <remusgabriel.chelu@disroot.org>

Această traducere este documentație gratuită; citiți Licența publică generală GNU Versiunea 3 (https://www.gnu.org/licenses/gpl-3.0.html) sau o versiune ulterioară cu privire la condiții privind drepturile de autor. NU se asumă NICIO RESPONSABILITATE.

Dacă găsiți erori în traducerea acestui manual, vă rugăm să trimiteți un e-mail la translation-team-ro@lists.sourceforge.net.